Bug 1295075 - Review Request: erlang-cache_tab - Erlang cache table application
Review Request: erlang-cache_tab - Erlang cache table application
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Randy Barlow
Fedora Extras Quality Assurance
:
Depends On: 1294587
Blocks: 1204119
  Show dependency treegraph
 
Reported: 2016-01-01 15:02 EST by Jeremy Cline
Modified: 2016-01-24 13:36 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-01-24 13:36:32 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rbarlow: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Jeremy Cline 2016-01-01 15:02:48 EST
Spec URL: https://jcline.fedorapeople.org/erlang-cache_tab.spec
SRPM URL: https://jcline.fedorapeople.org/erlang-cache_tab-1.0.1-1.fc23.src.rpm
Description: This application is intended to proxy back-end operations for Key-Value insert, lookup and delete and maintain a cache of those Key-Values in-memory, to save back-end operations. Operations are intended to be atomic between back-end and cache tables. The lifetime of the cache object and the max size of the cache can be defined as table parameters to limit the size of the in-memory tables.

This package depends on erlang-p1_utils, which is not yet in Fedora, so it cannot yet be built. See the blocking bug for its status.

There is one rpmlint warning:
erlang-cache_tab.x86_64: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

I believe we can ignore these warnings, as it is Erlang packaging convention to include all Erlang pacakges in %{_libdir}/erlang, and not all Erlang packages have binaries (like this one): https://fedoraproject.org/wiki/User:Peter/Erlang_Packaging_Guidelines
Comment 1 Upstream Release Monitoring 2016-01-04 17:46:00 EST
jcline's scratch build of erlang-cache_tab-1.0.1-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12408435
Comment 2 Randy Barlow 2016-01-05 00:31:06 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

A couple of things:

0) I think we should name this package erlang-p1_cache_tab and have it install to
%{_libdir}/erlang/lib/p1_cache_tab. Here is output for another dependency that is packaged that way
during the ejabberd build:

DEBUG: is_app_available, looking for App lager with Path "/home/rbarlow/rpmbuild/BUILD/ejabberd-15.11/deps/lager"
DEBUG: Directory expected to be an app dir, but it doesn't exist (yet?):
/home/rbarlow/rpmbuild/BUILD/ejabberd-15.11/deps/lager
DEBUG: is_app_available, looking for App lager with Path "/usr/lib64/erlang/lib/lager-1.2.2"
INFO:  Looking for lager-.* ; found lager-1.2.2 at /usr/lib64/erlang/lib/lager-1.2.2

This is the output when it is looking for p1_cache_tab:

DEBUG: is_app_available, looking for App p1_cache_tab with Path "/home/rbarlow/rpmbuild/BUILD/ejabberd-15.11/deps/p1_cache_tab"
DEBUG: Directory expected to be an app dir, but it doesn't exist (yet?):
/home/rbarlow/rpmbuild/BUILD/ejabberd-15.11/deps/p1_cache_tab
Dependency not available: p1_cache_tab-.* ({git,
                                            "https://github.com/processone/cache_tab",
                                            "f7ea12b0ba962a3d2f9a406d2954cf7de4e27230"})


1) I learned with my erlang-p1_utils package that we should not mark these packages as noarch,
because on x86_64 systems they will get installed to /usr/lib instead of to /usr/lib64. Strangely,
the test RPMs I've built with rpmbuild do not do this, but the build I released in Rawhide did. It
seems that rebar does not look at /usr/lib/erlang but only /usr/lib64/erlang when searching for
dependencies.


2) I don't think you will need to include the dep removal patch once I get a fixed version of
p1_utils pushed out to Rawhide (sorry!). Let's remove that patch and test.


3) I think we do want to Requires erlang-erts in these packages, as it is the package that owns
%{_libdir}/erlang. Note that the automated review text below was upset about not knowing who owned
that folder. However, I have just submitted a new build of erlang-p1_utils that depends on
erlang-erts and you depend on that package, so in this case I think you don't need to do anything.


Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 3 files have
     unknown license. Detailed output of licensecheck in
     /home/rbarlow/1295075-erlang-cache_tab/licensecheck.txt
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/erlang,
     /usr/lib64/erlang/lib
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[!]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: erlang-cache_tab-1.0.1-1.fc24.noarch.rpm
          erlang-cache_tab-1.0.1-1.fc24.src.rpm
erlang-cache_tab.noarch: W: only-non-binary-in-usr-lib
erlang-cache_tab.src:51: W: libdir-macro-in-noarch-package (main package) %{_libdir}/erlang/lib/%{srcname}-%{version}
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
erlang-cache_tab.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
erlang-cache_tab (rpmlib, GLIBC filtered):
    erlang-p1_utils



Provides
--------
erlang-cache_tab:
    erlang-cache_tab



Source checksums
----------------
https://github.com/processone/cache_tab/archive/1.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : 752b649f695e9f2777efd6b2d8dfdcc1f435104b4e363f5f0454b99fd009015c
  CHECKSUM(SHA256) upstream package : 752b649f695e9f2777efd6b2d8dfdcc1f435104b4e363f5f0454b99fd009015c


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1295075
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 3 Jeremy Cline 2016-01-07 22:42:44 EST
Spec URL: https://jcline.fedorapeople.org/erlang-p1_cache_tab.spec
SRPM URL: https://jcline.fedorapeople.org/erlang-p1_cache_tab-1.0.1-2.fc23.src.rpm

- Rename package to p1_cache_tab
- Removed noarch
- Removed dependency patch
- Depend on erlang-ert
- Skip eunit tests on i686

Because the updated version of erlang-p1_utils isn't in rawhide yet, I cannot do a proper koji scratch build.
Comment 4 Upstream Release Monitoring 2016-01-08 09:01:27 EST
jcline's scratch build of erlang-p1_cache_tab-1.0.1-2.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12466719
Comment 5 Upstream Release Monitoring 2016-01-08 09:57:40 EST
jcline's scratch build of erlang-p1_cache_tab-1.0.1-2.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12467120
Comment 6 Randy Barlow 2016-01-09 11:24:16 EST
This package fails to install, due to a typo on a Requires. It requires erlang-ert, but the package is actually called erlang-erts. FWIW, this package is also depending on erlang-p1_utils, which already depends on erlang-erts so IMO it's probably OK for you to not also depend on erts unless you want to. It's your call. It's tricky to do much more review like this though.

I also noticed that you didn't have a BuildRequires on erlang-eunit, but I guess somehow that's OK because your build does work. I had been listing that as a BuildRequires on mine but maybe something else is bringing that in?

Another note - I just noticed that the erlang macros have these:

%_erldir    %{_libdir}/erlang
%_erllibdir %{_erldir}/lib

Perhaps we should both be using these? I wouldn't consider it a blocker, but it does seem like a good idea. Sadly, none of my packages use them, womp womp. FYI, you can see the macros at /usr/lib/rpm/macros.d/macros.erlang. I suspect we also need the provides requires stuff (maybe then we don't need erts explicitly?)
Comment 7 Upstream Release Monitoring 2016-01-09 12:28:59 EST
jcline's scratch build of erlang-p1_cache_tab-1.0.1-3.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12484003
Comment 8 Jeremy Cline 2016-01-09 12:29:42 EST
Spec URL: https://jcline.fedorapeople.org/erlang-p1_cache_tab.spec
SRPM URL: https://jcline.fedorapeople.org/erlang-p1_cache_tab-1.0.1-3.fc23.src.rpm

- Fix the embarrasing typo of erlang-erts
- Explicitly depend on erlang-eunit for the build
- Use the Erlang directory macros
Comment 9 Randy Barlow 2016-01-09 13:57:36 EST
Package Review
==============

There are two problems with the package, but only one is a blocker. See
below.

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[!]: Package functions as described.
     Notes: ejabberd still doesn't think this is the right package. Here
     is some output from rpmbuild:

     DEBUG: is_app_available, looking for App p1_cache_tab with Path "/home/rbarlow/rpmbuild/BUILD/ejabberd-15.11/deps/p1_cache_tab"
     DEBUG: Directory expected to be an app dir, but it doesn't exist (yet?):
     /home/rbarlow/rpmbuild/BUILD/ejabberd-15.11/deps/p1_cache_tab
     DEBUG: is_app_available, looking for App p1_cache_tab with Path "/usr/lib64/erlang/lib/p1_cache_tab-1.0.1"
     WARN:  /usr/lib64/erlang/lib/p1_cache_tab-1.0.1/ebin/cache_tab.app has application id cache_tab; expected p1_cache_tab

     I'm not sure what the best course of action here is. It seems that
     upstream has created a confusing situation because ejabberd wants
     it to be called p1_cache_tab, but they've named the package
     cache_tab. Perhaps we should write their mailing list about it? In
     the meantime, this was included in the "SHOULD" section by
     fedora-review, but since it pertains to the name of this package which
     is difficult to change once it is included in Fedora, I've moved it to
     the MUST section.
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 2 files have unknown license. Detailed
     output of licensecheck in /home/rbarlow/1295075-erlang-
     p1_cache_tab/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

rbarlow-review:
[!]: I noticed that you have a check block, but the upstream source didn't
     look like it has unit tests. Did I miss something? If not, I suggest
     dropping it an removing the BuildRequires on eunit.

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: erlang-p1_cache_tab-1.0.1-3.fc24.x86_64.rpm
          erlang-p1_cache_tab-1.0.1-3.fc24.src.rpm
erlang-p1_cache_tab.x86_64: E: no-binary
erlang-p1_cache_tab.x86_64: W: only-non-binary-in-usr-lib
2 packages and 0 specfiles checked; 1 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
erlang-p1_cache_tab.x86_64: E: no-binary
erlang-p1_cache_tab.x86_64: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 1 errors, 1 warnings.



Requires
--------
erlang-p1_cache_tab (rpmlib, GLIBC filtered):
    erlang-erts
    erlang-p1_utils



Provides
--------
erlang-p1_cache_tab:
    erlang-p1_cache_tab
    erlang-p1_cache_tab(x86-64)



Source checksums
----------------
https://github.com/processone/cache_tab/archive/1.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : 752b649f695e9f2777efd6b2d8dfdcc1f435104b4e363f5f0454b99fd009015c
  CHECKSUM(SHA256) upstream package : 752b649f695e9f2777efd6b2d8dfdcc1f435104b4e363f5f0454b99fd009015c


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1295075
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 10 Randy Barlow 2016-01-09 14:18:06 EST
I just noticed that ejabberd's master branch has "cache_tab" as the dependency, instead of p1_cache_tab:

https://github.com/processone/ejabberd/blob/master/rebar.config#L13

Given this, I think we can patch ejabberd to look for cache_tab, as I believe the next release of ejabberd will have the dependency set that way. The version of cache_tab you are packaging was released after ejabberd-15.11 so they must have changed the dependency.

I also suggest renaming the package back to erlang-cache_tab to reflect this upstream change.

I wonder if they plan to do similar things for their other packages in the future. If so, we'll have to repackage any of them with the obsoletes/requires trick.

I'm going to go ahead and mark this as approved and plan to patch ejabberd to work with this name.

Approved on the condition that you rename the package to erlang-cache_tab.
Comment 11 Jeremy Cline 2016-01-09 17:07:14 EST
Just for your reference since this resulted in some pretty serious changes:

Spec URL: https://jcline.fedorapeople.org/erlang-cache_tab.spec
SRPM URL: https://jcline.fedorapeople.org/erlang-cache_tab-1.0.0-1.fc23.src.rpm

I bumped the version back down to 1.0.0 since this is getting packaged for ejabberd's use and that's the version they require in their rebar file.
Comment 12 Gwyn Ciesla 2016-01-09 17:49:01 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/erlang-cache_tab
Comment 13 Randy Barlow 2016-01-24 13:36:32 EST
I see that there is a build in Rawhide, so I think we can close this now.

Note You need to log in before you can comment on or make changes to this bug.